// Copyright
//
// This software is Copyright (c) 1994 - 2008, Engenic Communications Solutions Corporation
// http://www.enGenic.com
//
//
// License
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
// Executable code that uses provided source code, or derivative works thereof, may
// only be used in conjunction with TeleFlow.
//
// Redistributions of source code must retain the above copyright notice, this list
// of conditions and the following disclaimer.
//
// Redistributions in binary form must reproduce the above copyright notice, this
// list of conditions and the following disclaimer in the documentation, about box
// and/or other materials provided with the distribution.
//
// No personal names or organizations names associated with enGenic may be used to
// endorse or promote products derived from this software without specific prior
// written permission of the specific individual or organization.
//
//
// THIS SOFTWARE IS PROVIDED BY ENGENIC "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
// OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
// GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
// OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <ctype.h>   // isalpha, isdigit
#include <stdio.h>   // printf for debugging
#include <stdlib.h>  // atoi

#include "English_code.h"

English::English(void)
{
   InitialiseWordTable();
}

English::~English(void)
{
}

void English::InitialiseWordTable(void)
{
   // File names left this way for legacy reasons
   wordTable[WB_CARDINAL + 0] = "zero";
   wordTable[WB_CARDINAL + 1] = "one";
   wordTable[WB_CARDINAL + 2] = "two";
   wordTable[WB_CARDINAL + 3] = "three";
   wordTable[WB_CARDINAL + 4] = "four";
   wordTable[WB_CARDINAL + 5] = "five";
   wordTable[WB_CARDINAL + 6] = "six";
   wordTable[WB_CARDINAL + 7] = "seven";
   wordTable[WB_CARDINAL + 8] = "eight";
   wordTable[WB_CARDINAL + 9] = "nine";
   wordTable[WB_CARDINAL + 10] = "ten";
   wordTable[WB_CARDINAL + 11] = "eleven";
   wordTable[WB_CARDINAL + 12] = "twelve";
   wordTable[WB_CARDINAL + 13] = "thirteen";
   wordTable[WB_CARDINAL + 14] = "fourteen";
   wordTable[WB_CARDINAL + 15] = "fifteen";
   wordTable[WB_CARDINAL + 16] = "sixteen";
   wordTable[WB_CARDINAL + 17] = "seventeen";
   wordTable[WB_CARDINAL + 18] = "eighteen";
   wordTable[WB_CARDINAL + 19] = "nineteen";
   wordTable[WB_CARDINAL + 20] = "twenty";
   wordTable[WB_CARDINAL + 30] = "thirty";
   wordTable[WB_CARDINAL + 40] = "forty";
   wordTable[WB_CARDINAL + 50] = "fifty";
   wordTable[WB_CARDINAL + 60] = "sixty";
   wordTable[WB_CARDINAL + 70] = "seventy";
   wordTable[WB_CARDINAL + 80] = "eighty";
   wordTable[WB_CARDINAL + 90] = "ninety";
   wordTable[WB_ORDINAL + 1] = "first";
   wordTable[WB_ORDINAL + 2] = "second";
   wordTable[WB_ORDINAL + 3] = "third";
   wordTable[WB_ORDINAL + 4] = "fourth";
   wordTable[WB_ORDINAL + 5] = "fifth";
   wordTable[WB_ORDINAL + 6] = "sixth";
   wordTable[WB_ORDINAL + 7] = "seventh";
   wordTable[WB_ORDINAL + 8] = "eighth";
   wordTable[WB_ORDINAL + 9] = "nineth";
   wordTable[WB_ORDINAL + 10] = "tenth";
   wordTable[WB_ORDINAL + 11] = "eleventh";
   wordTable[WB_ORDINAL + 12] = "twelfth";
   wordTable[WB_ORDINAL + 13] = "thirteenth";
   wordTable[WB_ORDINAL + 14] = "fourteenth";
   wordTable[WB_ORDINAL + 15] = "fifteenth";
   wordTable[WB_ORDINAL + 16] = "sixteenth";
   wordTable[WB_ORDINAL + 17] = "seventeenth";
   wordTable[WB_ORDINAL + 18] = "eighteenth";
   wordTable[WB_ORDINAL + 19] = "nineteenth";
   wordTable[WB_ORDINAL + 20] = "twentieth";
   wordTable[WB_ORDINAL + 30] = "thirtieth";
   wordTable[WB_MONTH + 1] = "January";
   wordTable[WB_MONTH + 2] = "February";
   wordTable[WB_MONTH + 3] = "March";
   wordTable[WB_MONTH + 4] = "April";
   wordTable[WB_MONTH + 5] = "May";
   wordTable[WB_MONTH + 6] = "June";
   wordTable[WB_MONTH + 7] = "July";
   wordTable[WB_MONTH + 8] = "August";
   wordTable[WB_MONTH + 9] = "September";
   wordTable[WB_MONTH + 10] = "October";
   wordTable[WB_MONTH + 11] = "November";
   wordTable[WB_MONTH + 12] = "Dec";
   wordTable[WB_ASCII + ' '] = "space";
   wordTable[WB_ASCII + '!'] = "exclamation";
   wordTable[WB_ASCII + '\"'] = "double quote";
   wordTable[WB_ASCII + '#'] = "pound";
   wordTable[WB_ASCII + '$'] = "dollar sign";
   wordTable[WB_ASCII + '%'] = "percent sign";
   wordTable[WB_ASCII + '&'] = "ampersand";
   wordTable[WB_ASCII + '\''] = "single quote";
   wordTable[WB_ASCII + '('] = "open parenthesis";
   wordTable[WB_ASCII + ')'] = "close parenthesis";
   wordTable[WB_ASCII + '*'] = "asterisk";
   wordTable[WB_ASCII + '+'] = "plus";
   wordTable[WB_ASCII + ','] = "comma";
   wordTable[WB_ASCII + '-'] = "hyphen";
   wordTable[WB_ASCII + '.'] = "period";
   wordTable[WB_ASCII + '/'] = "forward slash";
   wordTable[WB_ASCII + ':'] = "colon";
   wordTable[WB_ASCII + ';'] = "semicolon";
   wordTable[WB_ASCII + '<'] = "less than";
   wordTable[WB_ASCII + '='] = "equal";
   wordTable[WB_ASCII + '>'] = "greater than";
   wordTable[WB_ASCII + '?'] = "question mark";
   wordTable[WB_ASCII + '@'] = "at sign";
   wordTable[WB_ASCII + '['] = "open square bracket";
   wordTable[WB_ASCII + '\\'] = "backslash";
   wordTable[WB_ASCII + ']'] = "close square bracket";
   wordTable[WB_ASCII + '^'] = "caret";
   wordTable[WB_ASCII + '_'] = "underscore";
   wordTable[WB_ASCII + '{'] = "open brace";
   wordTable[WB_ASCII + '|'] = "vertical bar";
   wordTable[WB_ASCII + '}'] = "close brace";
   wordTable[WB_ASCII + '~'] = "tilde";
   wordTable[WB_ASCII + ''] = "left angle quote";
   wordTable[WB_ASCII + ''] = "right angle quote";
}

WordList English::DateWordList(string date, LanguageModule::SAY_FORMAT format)
{
   string year = date.substr(0, 4);
   string month = date.substr(5, 2);
   string day = date.substr(8, 2);
   WordList wordList;

   switch(format)
   {
      // month-name cardinal-day YYYY
      case SAY_DATE:
      {
         wordList = wordTable[WB_MONTH + atoi(month.c_str())];
         wordList += IntegerWordList(day, true);
         wordList += IntegerWordList(year);
         break;
      }

      // DD de month-name
      case SAY_MONTHDAY:
      {
         wordList = IntegerWordList(day, true);
         wordList += wordTable[WB_MONTH + atoi(month.c_str())];
         break;
      }

      // month-name YYYY
      case SAY_YEARMONTH:
      {
         wordList = wordTable[WB_MONTH + atoi(month.c_str())];
         wordList += IntegerWordList(year);
         break;
      }
   }

   return(wordList);
}

WordList English::MoneyWordList(string money)
{
   WordList wordList;

   if(!Integer(money).empty())
   {
      wordList = IntegerWordList(Integer(money));
      wordList += atoi(Integer(money).c_str()) == 1 ? "dollar" : "dollars";

      if(!Fraction(money).empty())
      {
         wordList += "and";
      }
   }

   if(!Fraction(money).empty())
   {
      wordList += IntegerWordList(Fraction(money));
      wordList += atoi(Fraction(money).c_str()) == 1 ? "cent" : "cents";
   }

   return(wordList);
}

WordList English::NumberGroupWordList(string numberGroup, bool ordinal)
{
   WordList wordList;
   bool useTeen = false;
   string::iterator digit = numberGroup.begin();

   if(*digit == '+')
   {
      wordList += "positive";
      digit++;
   }
   else if(*digit == '-')
   {
      wordList += "negative";
      digit++;
   }

   for(; digit != numberGroup.end(); digit++)
   {
      switch(numberGroup.end() - digit)
      {
         // Hundreds column
         case 3:
         {
            if(*digit != '0')
            {
               wordList += wordTable[WB_CARDINAL + *digit - '0'];
               wordList += "hundred";
            }

            break;
         }

         // Tens column
         case 2:
         {
            if(*digit != '0')
            {
               if(*digit == '1')
               {
                  useTeen = true;
               }
               else if(*(digit + 1) == '0')
               {
                  wordList += wordTable[(ordinal ? WB_ORDINAL : WB_CARDINAL) + (*digit - '0')*10];
                  return(wordList);
               }
               else
               {
                  wordList += wordTable[WB_CARDINAL + (*digit - '0')*10];
               }
            }
            break;
         }

         // Ones column
         case 1:
         {
            if(useTeen)
            {
               wordList += wordTable[(ordinal ? WB_ORDINAL : WB_CARDINAL) + 10 + *digit - '0'];
            }
            else if(*digit != '0')
            {
               wordList += wordTable[(ordinal ? WB_ORDINAL : WB_CARDINAL) + *digit - '0'];
            }
            break;
         }
      }
   }

   return(wordList);
}

WordList English::NumberGroupWordList(int index, bool)
{
   WordList wordList;

   switch(index)
   {
      case 1:
      {
         wordList = "thousand";
         break;
      }

      case 2:
      {
         wordList = "million";
         break;
      }

      case 3:
      {
         wordList = "billion";
         break;
      }

      case 4:
      {
         wordList = "trillion";
         break;
      }
   }

   return(wordList);
}

WordList English::RealNumberWordList(string number)
{
   WordList wordList = IntegerWordList(Integer(number));

   if(!Fraction(number).empty())
   {
      string fraction = Fraction(number);

      wordList += "point";

      for(string::iterator digit = fraction.begin(); digit != fraction.end(); digit++)
      {
         wordList += wordTable[WB_CARDINAL + *digit - '0'];
      }
   }

   return(wordList);
}

WordList English::TimeWordList(string time, LanguageModule::SAY_FORMAT format)
{
   string hour = time.substr(0,2);
   string minute = time.substr(3,2);
   string second;
   WordList wordList;

   if(time.length() > 5)
   {
      second = time.substr(6,2);
   }

   if((format == SAY_12HOUR) && (atoi(hour.c_str()) > 12))
   {
      wordList = wordTable[WB_CARDINAL + atoi(hour.c_str()) - 12];
   }
   else if(atoi(hour.c_str()) == 0)
   {
      wordList = format == SAY_12HOUR ? "12" : "0";
   }
   else
   {
      wordList = IntegerWordList(hour);
   }

   if(atoi(minute.c_str()) == 0)
   {
      wordList += "oclock";
   }
   else
   {
      if(atoi(minute.c_str()) < 10)
      {
         wordList += "o";
      }

      wordList += IntegerWordList(minute);
   }

   if(!second.empty())
   {
      wordList += "and";
      wordList += IntegerWordList(second);
      wordList += atoi(second.c_str()) == 1 ? "second" : "seconds";
   }

   if(format == SAY_12HOUR)
   {
      wordList += atoi(hour.c_str()) >= 12 ? "pm" : "am";
   }

   return(wordList);
}

LanguageModule* CreateLanguageModule(void)
{
   return(new English());
}

void ReleaseLanguageModule(LanguageModule* lang)
{
   delete (English*) lang;
}
