// Copyright
//
// This software is Copyright (c) 1994 - 2008, Engenic Communications Solutions Corporation
// http://www.enGenic.com
//
//
// License
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
// Executable code that uses provided source code, or derivative works thereof, may
// only be used in conjunction with TeleFlow.
//
// Redistributions of source code must retain the above copyright notice, this list
// of conditions and the following disclaimer.
//
// Redistributions in binary form must reproduce the above copyright notice, this
// list of conditions and the following disclaimer in the documentation, about box
// and/or other materials provided with the distribution.
//
// No personal names or organizations names associated with enGenic may be used to
// endorse or promote products derived from this software without specific prior
// written permission of the specific individual or organization.
//
//
// THIS SOFTWARE IS PROVIDED BY ENGENIC "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
// OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
// GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
// OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <ctype.h>   // isalpha, isdigit
#include <stdio.h>   // printf for debugging
#include <stdlib.h>  // atoi

#include "English_code.h"

English::English(void)
{
   InitialiseWordTable();
}

English::~English(void)
{
}

void English::InitialiseWordTable(void)
{
   // File names left this way for legacy reasons
   wordTable[WB_CARDINAL + 0] = "00";
   wordTable[WB_CARDINAL + 1] = "01";
   wordTable[WB_CARDINAL + 2] = "02";
   wordTable[WB_CARDINAL + 3] = "03";
   wordTable[WB_CARDINAL + 4] = "04";
   wordTable[WB_CARDINAL + 5] = "05";
   wordTable[WB_CARDINAL + 6] = "06";
   wordTable[WB_CARDINAL + 7] = "07";
   wordTable[WB_CARDINAL + 8] = "08";
   wordTable[WB_CARDINAL + 9] = "09";
   wordTable[WB_CARDINAL + 10] = "10";
   wordTable[WB_CARDINAL + 11] = "11";
   wordTable[WB_CARDINAL + 12] = "12";
   wordTable[WB_CARDINAL + 13] = "13";
   wordTable[WB_CARDINAL + 14] = "14";
   wordTable[WB_CARDINAL + 15] = "15";
   wordTable[WB_CARDINAL + 16] = "16";
   wordTable[WB_CARDINAL + 17] = "17";
   wordTable[WB_CARDINAL + 18] = "18";
   wordTable[WB_CARDINAL + 19] = "19";
   wordTable[WB_CARDINAL + 20] = "20";
   wordTable[WB_CARDINAL + 30] = "30";
   wordTable[WB_CARDINAL + 40] = "40";
   wordTable[WB_CARDINAL + 50] = "50";
   wordTable[WB_CARDINAL + 60] = "60";
   wordTable[WB_CARDINAL + 70] = "70";
   wordTable[WB_CARDINAL + 80] = "80";
   wordTable[WB_CARDINAL + 90] = "90";
   wordTable[WB_ORDINAL + 1] = "1st";
   wordTable[WB_ORDINAL + 2] = "2nd";
   wordTable[WB_ORDINAL + 3] = "3rd";
   wordTable[WB_ORDINAL + 4] = "4th";
   wordTable[WB_ORDINAL + 5] = "5th";
   wordTable[WB_ORDINAL + 6] = "6th";
   wordTable[WB_ORDINAL + 7] = "7th";
   wordTable[WB_ORDINAL + 8] = "8th";
   wordTable[WB_ORDINAL + 9] = "9th";
   wordTable[WB_ORDINAL + 10] = "10th";
   wordTable[WB_ORDINAL + 11] = "11th";
   wordTable[WB_ORDINAL + 12] = "12th";
   wordTable[WB_ORDINAL + 13] = "13th";
   wordTable[WB_ORDINAL + 14] = "14th";
   wordTable[WB_ORDINAL + 15] = "15th";
   wordTable[WB_ORDINAL + 16] = "16th";
   wordTable[WB_ORDINAL + 17] = "17th";
   wordTable[WB_ORDINAL + 18] = "18th";
   wordTable[WB_ORDINAL + 19] = "19th";
   wordTable[WB_ORDINAL + 20] = "20th";
   wordTable[WB_ORDINAL + 30] = "30th";
   wordTable[WB_MONTH + 1] = "Jan";
   wordTable[WB_MONTH + 2] = "Feb";
   wordTable[WB_MONTH + 3] = "Mar";
   wordTable[WB_MONTH + 4] = "Apr";
   wordTable[WB_MONTH + 5] = "May";
   wordTable[WB_MONTH + 6] = "Jun";
   wordTable[WB_MONTH + 7] = "Jul";
   wordTable[WB_MONTH + 8] = "Aug";
   wordTable[WB_MONTH + 9] = "Sep";
   wordTable[WB_MONTH + 10] = "Oct";
   wordTable[WB_MONTH + 11] = "Nov";
   wordTable[WB_MONTH + 12] = "Dec";
   wordTable[WB_ASCII + ' '] = "space";
   wordTable[WB_ASCII + '!'] = "exclamation";
   wordTable[WB_ASCII + '\"'] = "dquote";
   wordTable[WB_ASCII + '#'] = "pound";
   wordTable[WB_ASCII + '$'] = "dsign";
   wordTable[WB_ASCII + '%'] = "percent";
   wordTable[WB_ASCII + '&'] = "ampersand";
   wordTable[WB_ASCII + '\''] = "squote";
   wordTable[WB_ASCII + '('] = "openparen";
   wordTable[WB_ASCII + ')'] = "closeparen";
   wordTable[WB_ASCII + '*'] = "asterisk";
   wordTable[WB_ASCII + '+'] = "plus";
   wordTable[WB_ASCII + ','] = "comma";
   wordTable[WB_ASCII + '-'] = "hyphen";
   wordTable[WB_ASCII + '.'] = "period";
   wordTable[WB_ASCII + '/'] = "fslash";
   wordTable[WB_ASCII + ':'] = "colon";
   wordTable[WB_ASCII + ';'] = "semicolon";
   wordTable[WB_ASCII + '<'] = "lessthan";
   wordTable[WB_ASCII + '='] = "equal";
   wordTable[WB_ASCII + '>'] = "morethan";
   wordTable[WB_ASCII + '?'] = "question";
   wordTable[WB_ASCII + '@'] = "atsign";
   wordTable[WB_ASCII + '['] = "lsqbracket";
   wordTable[WB_ASCII + '\\'] = "bslash";
   wordTable[WB_ASCII + ']'] = "rsqbracket";
   wordTable[WB_ASCII + '^'] = "caret";
   wordTable[WB_ASCII + '_'] = "underscore";
   wordTable[WB_ASCII + '{'] = "lbrace";
   wordTable[WB_ASCII + '|'] = "vertbar";
   wordTable[WB_ASCII + '}'] = "rbrace";
   wordTable[WB_ASCII + '~'] = "tilde";
   wordTable[WB_ASCII + ''] = "left angle quote";
   wordTable[WB_ASCII + ''] = "right angle quote";
}

WordList English::DateWordList(string date, LanguageModule::SAY_FORMAT format)
{
   string year = date.substr(0, 4);
   string month = date.substr(5, 2);
   string day = date.substr(8, 2);
   WordList wordList;

   switch(format)
   {
      // month-name ordinal-day YYYY
      case SAY_DATE:
      {
         wordList = wordTable[WB_MONTH + atoi(month.c_str())];
         wordList += IntegerWordList(day, true);
         if(atoi(year.c_str()) % 1000 < 10)
         {
            wordList += IntegerWordList(year);
         }
         else
         {
            wordList += IntegerWordList(year.substr(0, 2));
            wordList += IntegerWordList(year.substr(2, 2));
         }
         break;
      }

      // month-name ordinal-day
      case SAY_MONTHDAY:
      {
         wordList = wordTable[WB_MONTH + atoi(month.c_str())];
         wordList += IntegerWordList(day, true);
         break;
      }

      // month-name YYYY
      case SAY_YEARMONTH:
      {
         wordList = wordTable[WB_MONTH + atoi(month.c_str())];
         if(atoi(year.c_str()) % 1000 < 10)
         {
            wordList += IntegerWordList(year);
         }
         else
         {
            wordList += IntegerWordList(year.substr(0, 2));
            wordList += IntegerWordList(year.substr(2, 2));
         }
         break;
      }
   }

   return(wordList);
}

WordList English::MoneyWordList(string money)
{
   WordList wordList;

   if(!Integer(money).empty())
   {
      wordList = IntegerWordList(Integer(money));
      wordList += atoi(Integer(money).c_str()) == 1 ? "dollar" : "dollars";

      if(!Fraction(money).empty())
      {
         wordList += "and";
      }
   }

   if(!Fraction(money).empty())
   {
      wordList += IntegerWordList(Fraction(money));
      wordList += atoi(Fraction(money).c_str()) == 1 ? "cent" : "cents";
   }

   return(wordList);
}

WordList English::NumberGroupWordList(string numberGroup, bool ordinal)
{
   WordList wordList;
   bool useTeen = false;
   string::iterator digit = numberGroup.begin();

   if(*digit == '+')
   {
      wordList += "positive";
      digit++;
   }
   else if(*digit == '-')
   {
      wordList += "negative";
      digit++;
   }

   for(; digit != numberGroup.end(); digit++)
   {
      switch(numberGroup.end() - digit)
      {
         // Hundreds column
         case 3:
         {
            if(*digit != '0')
            {
               wordList += wordTable[WB_CARDINAL + *digit - '0'];
               wordList += "hundred";

               // Removed 'and' after 'hundred' based on customer feedback
               // if((*(digit + 1) != '0') || (*(digit + 2) != '0'))
               // {
               //    wordList += "and";
               // }
            }

            break;
         }

         // Tens column
         case 2:
         {
            if(*digit != '0')
            {
               if(*digit == '1')
               {
                  useTeen = true;
               }
               else if(*(digit + 1) == '0')
               {
                  wordList += wordTable[(ordinal ? WB_ORDINAL : WB_CARDINAL) + (*digit - '0')*10];
                  return(wordList);
               }
               else
               {
                  wordList += wordTable[WB_CARDINAL + (*digit - '0')*10];
               }
            }
            break;
         }

         // Ones column
         case 1:
         {
            if(useTeen)
            {
               wordList += wordTable[(ordinal ? WB_ORDINAL : WB_CARDINAL) + 10 + *digit - '0'];
            }
            else if(*digit != '0')
            {
               wordList += wordTable[(ordinal ? WB_ORDINAL : WB_CARDINAL) + *digit - '0'];
            }
            break;
         }
      }
   }

   return(wordList);
}

WordList English::NumberGroupWordList(int index, bool)
{
   WordList wordList;

   switch(index)
   {
      case 1:
      {
         wordList = "thousand";
         break;
      }

      case 2:
      {
         wordList = "million";
         break;
      }

      case 3:
      {
         wordList = "billion";
         break;
      }

      case 4:
      {
         wordList = "trillion";
         break;
      }
   }

   return(wordList);
}

WordList English::RealNumberWordList(string number)
{
   WordList wordList = IntegerWordList(Integer(number));

   if(!Fraction(number).empty())
   {
      string fraction = Fraction(number);

      wordList += "point";

      for(string::iterator digit = fraction.begin(); digit != fraction.end(); digit++)
      {
         wordList += wordTable[WB_CARDINAL + *digit - '0'];
      }
   }

   return(wordList);
}

WordList English::TimeWordList(string time, LanguageModule::SAY_FORMAT format)
{
   string hour = time.substr(0,2);
   string minute = time.substr(3,2);
   string second;
   WordList wordList;

   if(time.length() > 5)
   {
      second = time.substr(6,2);
   }

   if((format == SAY_12HOUR) && (atoi(hour.c_str()) > 12))
   {
      wordList = wordTable[WB_CARDINAL + atoi(hour.c_str()) - 12];
   }
   else if(atoi(hour.c_str()) == 0)
   {
      wordList = format == SAY_12HOUR ? "12" : "0";
   }
   else
   {
      wordList = IntegerWordList(hour);
   }

   if(atoi(minute.c_str()) == 0)
   {
      wordList += "oclock";
   }
   else
   {
      if(atoi(minute.c_str()) < 10)
      {
         wordList += "o";
      }

      wordList += IntegerWordList(minute);
   }

   if(!second.empty())
   {
      wordList += "and";
      wordList += IntegerWordList(second);
      wordList += atoi(second.c_str()) == 1 ? "second" : "seconds";
   }

   if(format == SAY_12HOUR)
   {
      wordList += atoi(hour.c_str()) >= 12 ? "pm" : "am";
   }

   return(wordList);
}

LanguageModule* CreateLanguageModule(void)
{
   return(new English());
}

void ReleaseLanguageModule(LanguageModule* lang)
{
   delete (English*) lang;
}
