#include "step_appgoto.h"

StepAppGoto::StepAppGoto(STEPREC& stepRecord) : Step(stepRecord)
{
   labelNm = stepRecord.s1.arr;
}

StepAppGoto::~StepAppGoto(void)
{
}

const char* StepAppGoto::GetStepName(void) const
{
	return("Go to Label");
}

// -------------------------------------------------------------------------
//   Name:        StepAppGoto::Execute
//
//   Purpose:     This function will return the label that the application
//                should jump to.  If the label is not found in the current
//                TAM, the application should pop any TAMs on the queue and
//                continue searching.
//   -----------------------------------------------------------------------
IV_STATUS StepAppGoto::Execute(PIVRINFO pInfo)
{
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Label", labelNm.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   SetNextLabel(value);

   delete[] value;

   return(IVR_GOTO);
}
