#include "step_fatal.h"

StepFatal::StepFatal(STEPREC& stepRecord) : Step(stepRecord)
{
   msg = stepRecord.s6.arr;
}

StepFatal::~StepFatal(void)
{
}

const char* StepFatal::GetStepName(void) const
{
	return("Fatal Stop");
}

IV_STATUS StepFatal::Execute(PIVRINFO pInfo)
{
   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if(!msg.empty())
   {
      char* pszText;

      if((pszText = pInfo->variables->ParseParameter("Message", msg.c_str(), "")) == NULL)
      {
         return(IVR_FATAL);
      }

      pInfo->ivLog->Print("      %s\n", pszText);

      delete[] pszText;
   }

   return(IVR_FATAL);
}
