#include "step_faxadd.h"
#include "..\BoardDLLs\brd_generic.h"

StepFaxAdd::StepFaxAdd(STEPREC& stepRecord) : Step(stepRecord)
{
   fileNm = stepRecord.s6.arr;
}

StepFaxAdd::~StepFaxAdd(void)
{
}

const char* StepFaxAdd::GetStepName(void) const
{
	return("Add to Fax");
}

IV_STATUS StepFaxAdd::Execute(PIVRINFO pInfo)
{
   IV_STATUS  status;
   char* value;
   char* pathName;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if((value = pInfo->variables->ParseParameter("File to add", fileNm.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   pathName = pInfo->variables->FilePath(value);
   pInfo->ivLog->Print("      Adding file '%s' \n", pathName);
   delete[] value;

   status = pInfo->ivBoard->FaxQueueAdd(pathName);
   delete[] pathName;

   if(status == IVR_NOTSUPPORTED)
   {
	   pInfo->ivLog->Print("      Faxing option not installed.\n");
   }

   return(status);
}
