#include <stdlib.h>             // Needed for "atoi".
#include "step_flashhook.h"
#include "..\BoardDLLs\brd_generic.h"

StepFlashHook::StepFlashHook(STEPREC& stepRecord) : Step(stepRecord)
{
   duration = stepRecord.s1.arr;
}

StepFlashHook::~StepFlashHook(void)
{
}

const char* StepFlashHook::GetStepName(void) const
{
	return("Flash Hook");
}

IV_STATUS StepFlashHook::Execute(PIVRINFO pInfo)
{
   int flashTime;
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if((value = pInfo->variables->ParseParameter("On-hook time", duration.c_str(), "500")) == NULL)
   {
      return(IVR_FATAL);
   }

   flashTime = atoi(value);
   delete[] value;

   if(flashTime < 0)
   {
		pInfo->ivLog->Print("      ERROR: On-hook time '%s' must be >= 0\n", duration.c_str());
      return(IVR_FATAL);
   }

   return(pInfo->ivBoard->FlashHook(flashTime));
}
