#include "step_noop.h"

StepNoOp::StepNoOp(STEPREC& stepRecord) : Step(stepRecord)
{
   switch((Step::OP_CODE) stepRecord.op)
   {
      case Step::LABEL:
      {
         stepTitle = "Label";
         SetLabel(stepRecord.label.arr);
         break;
      }

      case Step::COMMENTS:   stepTitle = "Notes";  break;
      case Step::SPACEPOINT: stepTitle = "Connect Point";  break;
   }
}

StepNoOp::~StepNoOp(void)
{
}

const char* StepNoOp::GetStepName(void) const
{
	return(stepTitle.c_str());
}

// -------------------------------------------------------------------------
//   Name:        StepNoOp::Execute
//
//   Purpose:     Some steps don't do anything but need to be kept to allow
//                flow through the step to next step.  For example SPACEPOINT
//                and LABEL.
// -------------------------------------------------------------------------
IV_STATUS StepNoOp::Execute(PIVRINFO pInfo)
{
   const char* pszLabel = GetLabel();

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((pszLabel != NULL)  && (pszLabel[0] != '\0'))
   {
         pInfo->ivLog->Print("      Label: %s\n", pszLabel);
   }

   return(IVR_SUCCESS);
}
