#ifndef STEP_PLACECALL_H
#define STEP_PLACECALL_H

#include "step.h"
#include "..\BoardDLLs\brd_generic.h"

// -------------------------------------------------------------------------
//   Class:     StepPlaceCall
//
//   Modified:  Feb 08/02 - TF: Added pszCallerID for future support of
//                 PlaceCall sending application defined Caller ID with
//                 the call.
//
//              Jul 08/02 - TF: Changed to support new @PORT setting from
//                 version 4 TAL file
// -------------------------------------------------------------------------
class StepPlaceCall : public Step
{
   public:

      StepPlaceCall(STEPREC& stepRecord);
      virtual ~StepPlaceCall(void);

		const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

   protected:

      string ring;
      string phone;
      string callerID;
      string flashDuration;
      string voiceLengthVariable;
      string silenceTimeout;
      string maxVoiceTimeout;
      string isdnCallingNumberPlan;
      string isdnCallingNumberType;
      string isdnCalledNumParms;
      bool bSameLine;
      bool bConnectOnCED;
      bool bConnectOnSIT;

      bool EvaluateNumberPlan(const char* pszPlan, BoardGeneric::ISDNNumberPlan& enumPlan);
      bool EvaluateNumberType(const char* pszType, BoardGeneric::ISDNNumberType& enumType);
};

#endif
