#include "step_tones.h"

StepTones::StepTones(STEPREC& stepRecord) : Step(stepRecord)
{
}

StepTones::~StepTones(void)
{
}

int StepTones::GetTT(int index)
{
   return(TT[index]);
}

int StepTones::GetTTOther(void)
{
   return(ttOther);
}

// -------------------------------------------------------------------------
//   Name:        StepTones::SetTT
//
//   Notes:       - IVRTTOTHER must be defined first.  It sets all TT fields
//                  to the same step.
//                - We could initialize all TT fields to 0 and TTOTHER could
//                  be set at the end to set all TT fields that are still 0.
//                - If StepID is less than 1, then it should not overwrite the
//                  value of TTOTHER.
// -------------------------------------------------------------------------
void StepTones::SetTT (int TTID, int StepID)
{
   if((TTID != IVRTTOTHER) && (StepID <= 0))
   {
      return;
   }

   switch (TTID)
   {
      case IVRTTOTHER:         // Initialize all TT next ids to the same value.
      {
         for(int index = 0; index < 16; index++)
         {
            TT[index] = StepID;
         }
         ttOther = StepID;
         break;
      }

      case IVRTT0:     TT[0]  = StepID; break;
      case IVRTT1:     TT[1]  = StepID; break;
      case IVRTT2:     TT[2]  = StepID; break;
      case IVRTT3:     TT[3]  = StepID; break;
      case IVRTT4:     TT[4]  = StepID; break;
      case IVRTT5:     TT[5]  = StepID; break;
      case IVRTT6:     TT[6]  = StepID; break;
      case IVRTT7:     TT[7]  = StepID; break;
      case IVRTT8:     TT[8]  = StepID; break;
      case IVRTT9:     TT[9]  = StepID; break;
      case IVRTTA:     TT[10] = StepID; break;
      case IVRTTB:     TT[11] = StepID; break;
      case IVRTTC:     TT[12] = StepID; break;
      case IVRTTD:     TT[13] = StepID; break;
      case IVRTTSTAR:  TT[14] = StepID; break;
      case IVRTTPOUND: TT[15] = StepID; break;
   }
}
