#ifndef TFSERVERREGISTRATIONINFO_H
#define TFSERVERREGISTRATIONINFO_H

#include "file_log.h"

// Helper class to load all of the TFServer information from the registry and set
// defaults for missing information
class TFServerRegistrationInfo
{
   public:

      TFServerRegistrationInfo(void);

      // Cleans up dynamic memory
      virtual ~TFServerRegistrationInfo(void);

      // Cleans up dynamic memory
      void Clear(void);

      // Allocates the necessary dynamic memory and loads the settings from the registry
      bool Load(FileLog& sysLog);

      // Opens a system log with the settings in the registry
      bool OpenSystemLog(FileLog& sysLog);

      char* pszBoardDLL;
      char* pszInstallationPath;
      char* pszLogDir;
      char* pszAppListFileNm;
      char* pszTFStart;
      DWORD dwMonitorPort;
      DWORD dwMonitorHTTPPort;
      DWORD dwLogLines;
      DWORD	dwMaxLogFileSize;
      DWORD	dwLogSRAudio;
};

#endif


 