// ----------------------------------------------------------------------------
// TeleFlow Open Server
//
// Copyright (C) 2008 engenic (engenic.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------

#ifndef LICENSEREAD_H
#define LICENSEREAD_H

#include "file_log.h"

// Possible license states
enum LICENSE_STATUS { UNLICENSED,
                      TEMPORARY,
                      LICENSED,
                      GPL
                    };

typedef struct
{
   LICENSE_STATUS licensetype;   // TeleFlow license type (see ivr_defs.h)
   int   numports;               // Number of ports that are licensed
   int   numdays;                // Number of days left (applies to a temp license only)
} TFLICENSESTRUCT;

TFLICENSESTRUCT ReadLicense(FileLog* ivLog = NULL);

#endif
