/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
#ifndef THREADLINK_H
#define THREADLINK_H

#include <windows.h>
#include <string.h>
#include "signalevt.h"
#include "..\escutil\link.h"
#include "file_log.h"
#include "TFServer_Communication.h"

typedef struct
{
   SignalEvent<int>      *mySignal;     // Service events arrive on this queue.
   CommunicationHub<TFServerCommunicationPacket::TF_DESTINATION_ID>* commHub; // Server events sent on this queue.
   HANDLE                 hThread;      // Identifies msgs sent to service.
   void                  *data;         // Additional data for special threads.
   FileLog               *sysLog;
   bool                   bDebug;
} THREAD_CTRL_INFO;

/* -------------------------------------------------------------------------
   Class:       ThreadLink

   Purpose:     The Service thread needs to know about all the threads
                created so that the threads can be notified when the service
                is about to terminate.  Once notified, the threads have 20
                seconds to finish off tasks before the service terminates.
   ------------------------------------------------------------------------- */
class ThreadLink : public Link
{
public:
   THREAD_CTRL_INFO  tInfo;
   unsigned (__stdcall *start)(void *);

   ThreadLink() : Link()
   {
      pszName = 0;
      start = 0;
      tInfo.mySignal = new SignalEvent<int>;
   }
   ~ThreadLink()
   {
      delete tInfo.mySignal;
      delete [] pszName;
   }
   void SetName (char *pszValue)
   {
      pszName = new char [strlen (pszValue) + 1];
      strcpy (pszName, pszValue);
   }
   char * GetName() { return pszName; }
private:
   char *pszName;
};

#endif
