#include "criticalsection.h"

CriticalSection::CriticalSection(void) : count(0)
{
   InitializeCriticalSection(&cs);
}

CriticalSection::~CriticalSection(void)
{
   while(count > 0)
   {
      Leave();
   }
   DeleteCriticalSection(&cs);
}

void CriticalSection::Enter(void)
{
   EnterCriticalSection(&cs);
   count++;
}

void CriticalSection::Leave(void)
{
   LeaveCriticalSection(&cs);
   count--;
}

Mutex::Mutex(void) : count(0)
{
    mhandle = CreateMutex(NULL, false, NULL);
}

Mutex::~Mutex(void)
{
   while(count > 0)
   {
      Release();
   }
   CloseHandle(mhandle);
}

void Mutex::Get(void)
{
   WaitForSingleObject(mhandle, INFINITE);
   count++;
}

void Mutex::Release(void)
{
   ReleaseMutex(mhandle);
   count--;
}
