/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
#include "esc_except.h"

ESC_EXCEPT_INFO g_exceptInfo;

/* -------------------------------------------------------------------------
   Name:        ESCExceptionLocation
   ------------------------------------------------------------------------- */
int ESCExceptionLocation (ESC_EXCEPT_INFO *info, const char *pszFnNm)
{
   if (info && !info->pszLocation) {
      if (pszFnNm)
         info->pszLocation = pszFnNm;
      else
         info->bChildException = true;
   }
   return EXCEPTION_CONTINUE_SEARCH;
}
/*ESCExceptionLocation*/

/* -------------------------------------------------------------------------
   Name:        ESCExceptionFilter
   ------------------------------------------------------------------------- */
int ESCExceptionFilter (ESC_EXCEPT_INFO *info)
{
   EXCEPTION_RECORD *xr;

   if (!info || !info->xp) return EXCEPTION_CONTINUE_SEARCH;

   xr = info->xp->ExceptionRecord;
// while (xr)
// {
      info->dwLocation = xr->ExceptionAddress;

      switch (xr->ExceptionCode)
      {
      case EXCEPTION_ACCESS_VIOLATION:
         info->pszExceptName = "EXCEPTION_ACCESS_VIOLATION";
         info->bAV = true;
         info->bAVWrite = (bool)xr->ExceptionInformation[0];
         info->dwAVLocation = xr->ExceptionInformation[1];
//       ivLog->Print ("EXCEPTION_ACCESS_VIOLATION attempting to "
//                     "%s at location %lX\n",
//                     (xr->ExceptionInformation[0] ? "write" : "read"),
//                     xr->ExceptionInformation[1]);
         break;
      case EXCEPTION_ARRAY_BOUNDS_EXCEEDED:
         info->pszExceptName = "EXCEPTION_ARRAY_BOUNDS_EXCEEDED";
         break;
      case EXCEPTION_BREAKPOINT:
         info->pszExceptName = "EXCEPTION_BREAKPOINT";
         break;
      case EXCEPTION_DATATYPE_MISALIGNMENT:
         info->pszExceptName = "EXCEPTION_DATATYPE_MISALIGNMENT";
         break;
      case EXCEPTION_FLT_DENORMAL_OPERAND:
         info->pszExceptName = "EXCEPTION_FLT_DENORMAL_OPERAND";
         break;
      case EXCEPTION_FLT_DIVIDE_BY_ZERO:
         info->pszExceptName = "EXCEPTION_FLT_DIVIDE_BY_ZERO";
         break;
      case EXCEPTION_FLT_INEXACT_RESULT:
         info->pszExceptName = "EXCEPTION_FLT_INEXACT_RESULT";
         break;
      case EXCEPTION_FLT_INVALID_OPERATION:
         info->pszExceptName = "EXCEPTION_FLT_INVALID_OPERATION";
         break;
      case EXCEPTION_FLT_OVERFLOW:
         info->pszExceptName = "EXCEPTION_FLT_OVERFLOW";
         break;
      case EXCEPTION_FLT_STACK_CHECK:
         info->pszExceptName = "EXCEPTION_FLT_STACK_CHECK";
         break;
      case EXCEPTION_FLT_UNDERFLOW:
         info->pszExceptName = "EXCEPTION_FLT_UNDERFLOW";
         break;
      case EXCEPTION_ILLEGAL_INSTRUCTION:
         info->pszExceptName = "EXCEPTION_ILLEGAL_INSTRUCTION";
         break;
      case EXCEPTION_IN_PAGE_ERROR:
         info->pszExceptName = "EXCEPTION_IN_PAGE_ERROR";
         break;
      case EXCEPTION_INT_DIVIDE_BY_ZERO:
         info->pszExceptName = "EXCEPTION_INT_DIVIDE_BY_ZERO";
         break;
      case EXCEPTION_INT_OVERFLOW:
         info->pszExceptName = "EXCEPTION_INT_OVERFLOW";
         break;
      case EXCEPTION_INVALID_DISPOSITION:
         info->pszExceptName = "EXCEPTION_INVALID_DISPOSITION";
         break;
      case EXCEPTION_NONCONTINUABLE_EXCEPTION:
         info->pszExceptName = "EXCEPTION_NONCONTINUABLE_EXCEPTION";
         break;
      case EXCEPTION_PRIV_INSTRUCTION:
         info->pszExceptName = "EXCEPTION_PRIV_INSTRUCTION";
         break;
      case EXCEPTION_SINGLE_STEP:
         info->pszExceptName = "EXCEPTION_SINGLE_STEP";
         break;
      case EXCEPTION_STACK_OVERFLOW:
         info->pszExceptName = "EXCEPTION_STACK_OVERFLOW";
         break;
      default:
         info->pszExceptName = "UNKNOWN EXCEPTION";
      }
//    xr = xr->ExceptionRecord;
// }
   // Always handle all exceptions.
   return EXCEPTION_EXECUTE_HANDLER;
}
/*ESCExceptionFilter*/


