#ifndef __SMTPRESPONSE_H__
#define __SMTPRESPONSE_H__

#ifdef __DLL__
#define SMTPRESPONSEAPI __declspec(dllexport)
#else
#define SMTPRESPONSEAPI __declspec(dllimport)
#endif

#include <string>
using std::string;

#include "InternetMessage.h"

class SMTPRESPONSEAPI SMTPResponse : public InternetMessage
{
   public:

      enum STATUS_CODE
      {
         INVALID_STATUS = -1
      };

      // Format: "XXX MMMMMMMM\r\n"
      // where XXX is the status code, and MMMMMMMM is the response text

      SMTPResponse(void);
      virtual ~SMTPResponse(void);

      // Returns the response text that follows status code, after the space
      virtual const char* GetResponseText(void);

      // Returns the status code
      // Returns INVALID_STATUS if the status code is not present, or the status
      // code contains non-numeric data
      virtual SMTPResponse::STATUS_CODE GetStatusCode(void);

      // Returns true if the complete message has been received, including multiple
      // responses for SMTP extensions
      // Returns false if a message terminator "\r\n" is not present
      virtual bool HaveCompleteMessage(void);

   protected:

      string responseText;

      void LoadLastResponse(void);
};

#endif

